//    |  /           |
//    ' /   __| _` | __|  _ \   __|
//    . \  |   (   | |   (   |\__ `
//   _|\_\_|  \__,_|\__|\___/ ____/
//                   Multi-Physics
//
//  License:		 BSD License
//					 Kratos default license: kratos/license.txt
//
//  Main authors:    Pooyan Dadvand
//                   Riccardo Rossi
//


// System includes

// External includes

// Project includes
#include "includes/define_python.h"
#include "includes/legacy_structural_app_vars.h"



namespace Kratos
{

namespace Python
{
namespace py = pybind11;

void  AddLegacyStructuralAppVarsToPython(pybind11::module& m)
{
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, LAMBDAS_T )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, DELTA_LAMBDAS_T )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, CONTACT_LINK_M )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, AUXILIARY_MATRIX_1 )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, ELASTIC_LEFT_CAUCHY_GREEN_OLD )

        KRATOS_REGISTER_IN_PYTHON_3D_VARIABLE_WITH_COMPONENTS(m, DISPLACEMENT_OLD )
        KRATOS_REGISTER_IN_PYTHON_3D_VARIABLE_WITH_COMPONENTS(m, DISPLACEMENT_DT )
        KRATOS_REGISTER_IN_PYTHON_3D_VARIABLE_WITH_COMPONENTS(m, DISPLACEMENT_NULL )
        KRATOS_REGISTER_IN_PYTHON_3D_VARIABLE_WITH_COMPONENTS(m, DISPLACEMENT_NULL_DT )
        KRATOS_REGISTER_IN_PYTHON_3D_VARIABLE_WITH_COMPONENTS(m, ACCELERATION_NULL )
        KRATOS_REGISTER_IN_PYTHON_3D_VARIABLE_WITH_COMPONENTS(m, DISPLACEMENT_EINS )
        KRATOS_REGISTER_IN_PYTHON_3D_VARIABLE_WITH_COMPONENTS(m, DISPLACEMENT_EINS_DT )
        KRATOS_REGISTER_IN_PYTHON_3D_VARIABLE_WITH_COMPONENTS(m, ACCELERATION_EINS )

        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, PENALTY_T )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, LAMBDAS )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, GAPS )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, DELTA_LAMBDAS )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, STICK )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, CONTACT_STICK )

        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, USE_DISTRIBUTED_PROPERTIES )

        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, CONTACT_RAMP )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, CONTACT_SLAVE_INTEGRATION_POINT_INDEX )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, CONTACT_DOUBLE_CHECK )
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, FIRST_TIME_STEP )
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, QUASI_STATIC_ANALYSIS )


//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, OSS_SWITCH )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, WRINKLING_APPROACH )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, CALCULATE_INSITU_STRESS )
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, PERIODIC_PAIR_INDEX )
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, STATIONARY )

//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, PARTITION_MASK )

//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, FACE_HEAT_FLUX )

//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, NODAL_VOLUME )

        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, PRESSURE_DT )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, WATER_PRESSURE_DT )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, WATER_PRESSURE_NULL )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, WATER_PRESSURE_NULL_DT )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, WATER_PRESSURE_NULL_ACCELERATION )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, WATER_PRESSURE_EINS )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, WATER_PRESSURE_EINS_DT )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, WATER_PRESSURE_EINS_ACCELERATION )

        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, AIR_PRESSURE_DT )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, AIR_PRESSURE_ACCELERATION )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, AIR_PRESSURE_NULL )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, AIR_PRESSURE_NULL_DT )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, AIR_PRESSURE_NULL_ACCELERATION )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, AIR_PRESSURE_EINS )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, AIR_PRESSURE_EINS_DT )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, AIR_PRESSURE_EINS_ACCELERATION )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, SUCTION )
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, FLAG_VARIABLE )

//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, DP_EPSILON )
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, DP_ALPHA1 )
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, DP_K )

//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, EQ_STRAIN_RATE )
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, RHS_WATER )
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, RHS_AIR )

        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, PERMEABILITY_28_DAYS )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, PERMEABILITY_1_DAY )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, PERMEABILITY_TRANSITION )

//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, TEMPERATURE_OLD_IT )
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, EFFECTIVE_VISCOSITY )
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, KINEMATIC_VISCOSITY)
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, DYNAMIC_VISCOSITY)
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, WEIGHT_FATHER_NODES )

        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, PARENT_ELEMENT_ID )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, INTEGRATION_POINT_INDEX )

        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, IS_CONTACT_MASTER )
        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, IS_CONTACT_SLAVE )
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, IS_BOUNDARY )
//        KRATOS_REGISTER_IN_PYTHON_VARIABLE(m, IS_VISITED )
}
}  // namespace Python.
} // Namespace Kratos

#undef KRATOS_REGISTER_IN_PYTHON_IN_PYTHON_FLAG
#undef KRATOS_REGISTER_IN_PYTHON_IN_PYTHON_VARIABLE
#undef KRATOS_REGISTER_IN_PYTHON_IN_PYTHON_3D_VARIABLE_WITH_COMPONENTS
